using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;
using Syncfusion.Windows.Forms.Tools;  
using Syncfusion.Windows.Forms.Grid; 
using System.Globalization;    

namespace StaffTravel
{
	/// <summary>
	/// Summary description for Library.
	/// </summary>
	public class Library : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private Syncfusion.Windows.Forms.Tools.GradientPanel gradientPanel2;
		private System.Windows.Forms.ImageList TreeImages;
		private System.Windows.Forms.Label lblDescription;
		private System.Windows.Forms.Label lblHeader;
		private Syncfusion.Windows.Forms.Tools.TreeViewAdv libtree;
		private System.ComponentModel.IContainer components;

		//Variables
		string ErrMsg;bool retval;DataSet libDS;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid libgrid;
		SqlDataReader MyReader;
		static bool NewRow;
		static int Rowindex=0;		
		static ArrayList ReadCols;
		private System.Windows.Forms.Label label1;
		private Syncfusion.Windows.Forms.Tools.GradientPanel gradientPanel1;
		StaffTravel.Connection conn;

		/// <summary>
		/// Initialize Variables in the Form Constructor
		/// </summary>
		public Library()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			ErrMsg="";
			retval = false;			
			libDS = new DataSet("libDS"); 			
			NewRow=false;

			ReadCols = new ArrayList();
			ReadCols.Add("Code@STRV_SalGradeEnt");
			ReadCols.Add("sector@STRV_FaresID");

			conn = new Connection(); 	

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo treeNodeAdvStyleInfo1 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo();
			Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo treeNodeAdvStyleInfo2 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Library));
			Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle1 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
			Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle2 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
			Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle3 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
			Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle4 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
			this.libtree = new Syncfusion.Windows.Forms.Tools.TreeViewAdv();
			this.TreeImages = new System.Windows.Forms.ImageList(this.components);
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.libgrid = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.gradientPanel2 = new Syncfusion.Windows.Forms.Tools.GradientPanel();
			this.lblDescription = new System.Windows.Forms.Label();
			this.lblHeader = new System.Windows.Forms.Label();
			this.panel2 = new System.Windows.Forms.Panel();
			this.gradientPanel1 = new Syncfusion.Windows.Forms.Tools.GradientPanel();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.libtree)).BeginInit();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.libgrid)).BeginInit();
			this.gradientPanel2.SuspendLayout();
			this.panel2.SuspendLayout();
			this.gradientPanel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// libtree
			// 
			this.libtree.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(253)), ((System.Byte)(252)), ((System.Byte)(246)));
			this.libtree.BackgroundColor = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((System.Byte)(253)), ((System.Byte)(252)), ((System.Byte)(246))));
			treeNodeAdvStyleInfo1.EnsureDefaultOptionedChild = true;
			treeNodeAdvStyleInfo1.LeftImageIndices = new int[] {
																   1};
			treeNodeAdvStyleInfo2.EnsureDefaultOptionedChild = true;
			treeNodeAdvStyleInfo2.LeftImageIndices = new int[] {
																   0};
			this.libtree.BaseStylePairs.AddRange(new Syncfusion.Windows.Forms.Tools.StyleNamePair[] {
																										new Syncfusion.Windows.Forms.Tools.StyleNamePair("NodeLevel1", treeNodeAdvStyleInfo1),
																										new Syncfusion.Windows.Forms.Tools.StyleNamePair("Standard", treeNodeAdvStyleInfo2)});
			this.libtree.BorderColor = System.Drawing.Color.Empty;
			this.libtree.BorderSides = ((System.Windows.Forms.Border3DSide)((System.Windows.Forms.Border3DSide.Top | System.Windows.Forms.Border3DSide.Right)));
			this.libtree.Dock = System.Windows.Forms.DockStyle.Fill;
			// 
			// libtree.HelpTextControl
			// 
			this.libtree.HelpTextControl.BackgroundColor = new Syncfusion.Drawing.BrushInfo();
			this.libtree.HelpTextControl.Border3DStyle = System.Windows.Forms.Border3DStyle.Sunken;
			this.libtree.HelpTextControl.BorderSingle = System.Windows.Forms.ButtonBorderStyle.Solid;
			this.libtree.HelpTextControl.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.libtree.HelpTextControl.IgnoreKeys = true;
			this.libtree.HelpTextControl.Location = new System.Drawing.Point(732, 0);
			this.libtree.HelpTextControl.Name = "helpText";
			this.libtree.HelpTextControl.RestrictWidth = 0;
			this.libtree.HelpTextControl.Size = new System.Drawing.Size(50, 17);
			this.libtree.HelpTextControl.TabIndex = 0;
			this.libtree.HelpTextControl.Text = "help text";
			this.libtree.HelpTextControl.Visible = false;
			this.libtree.HorizontalThumbTrack = true;
			this.libtree.InactiveSelectedNodeBackground = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(10)), ((System.Byte)(36)), ((System.Byte)(106))));
			this.libtree.KeepDottedSelection = true;
			this.libtree.KeepDragCapturePoint = true;
			this.libtree.LeftImageList = this.TreeImages;
			this.libtree.LineColor = System.Drawing.Color.Black;
			this.libtree.Location = new System.Drawing.Point(0, 40);
			this.libtree.Name = "libtree";
			this.libtree.SelectedNodeBackground = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(10)), ((System.Byte)(36)), ((System.Byte)(106))));
			this.libtree.SelectedNodeForeColor = System.Drawing.Color.Black;
			this.libtree.Size = new System.Drawing.Size(240, 593);
			this.libtree.SmartSizeBox = false;
			this.libtree.TabIndex = 0;
			// 
			// libtree.ToolTipControl
			// 
			this.libtree.ToolTipControl.BackColor = System.Drawing.SystemColors.Info;
			this.libtree.ToolTipControl.BackgroundColor = new Syncfusion.Drawing.BrushInfo();
			this.libtree.ToolTipControl.Border3DStyle = System.Windows.Forms.Border3DStyle.Sunken;
			this.libtree.ToolTipControl.BorderSingle = System.Windows.Forms.ButtonBorderStyle.Solid;
			this.libtree.ToolTipControl.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.libtree.ToolTipControl.IgnoreKeys = true;
			this.libtree.ToolTipControl.Location = new System.Drawing.Point(642, 0);
			this.libtree.ToolTipControl.Name = "toolTip";
			this.libtree.ToolTipControl.RestrictWidth = 0;
			this.libtree.ToolTipControl.Size = new System.Drawing.Size(41, 17);
			this.libtree.ToolTipControl.TabIndex = 1;
			this.libtree.ToolTipControl.Text = "toolTip";
			this.libtree.ToolTipControl.Visible = false;
			this.libtree.VerticalThumbTrack = true;
			this.libtree.VScrollPos = 1;
			this.libtree.AfterSelect += new System.EventHandler(this.libtree_AfterSelect);
			// 
			// TreeImages
			// 
			this.TreeImages.ImageSize = new System.Drawing.Size(16, 16);
			this.TreeImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("TreeImages.ImageStream")));
			this.TreeImages.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(1016, 108);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 1;
			this.pictureBox1.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.libgrid);
			this.panel1.Controls.Add(this.gradientPanel2);
			this.panel1.Controls.Add(this.panel2);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 108);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(1016, 633);
			this.panel1.TabIndex = 2;
			// 
			// libgrid
			// 
			this.libgrid.AllowDragSelectedCols = true;
			this.libgrid.AllowResizeToFit = false;
			this.libgrid.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)));
			this.libgrid.BackColor = System.Drawing.SystemColors.Control;
			gridBaseStyle1.Name = "Header";
			gridBaseStyle1.StyleInfo.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
			gridBaseStyle1.StyleInfo.Borders.Left = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
			gridBaseStyle1.StyleInfo.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
			gridBaseStyle1.StyleInfo.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
			gridBaseStyle1.StyleInfo.CellType = "Header";
			gridBaseStyle1.StyleInfo.Font.Bold = true;
			gridBaseStyle1.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((System.Byte)(222)), ((System.Byte)(210)), ((System.Byte)(162))), System.Drawing.Color.FromArgb(((System.Byte)(252)), ((System.Byte)(249)), ((System.Byte)(240))));
			gridBaseStyle1.StyleInfo.TextColor = System.Drawing.Color.Black;
			gridBaseStyle1.StyleInfo.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Middle;
			gridBaseStyle2.Name = "Column Header";
			gridBaseStyle2.StyleInfo.BaseStyle = "Header";
			gridBaseStyle2.StyleInfo.CellType = "ColumnHeaderCell";
			gridBaseStyle2.StyleInfo.Enabled = false;
			gridBaseStyle2.StyleInfo.Font.Bold = false;
			gridBaseStyle2.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Center;
			gridBaseStyle3.Name = "Row Header";
			gridBaseStyle3.StyleInfo.BaseStyle = "Header";
			gridBaseStyle3.StyleInfo.CellType = "RowHeaderCell";
			gridBaseStyle3.StyleInfo.Enabled = true;
			gridBaseStyle3.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Left;
			gridBaseStyle3.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.Control);
			gridBaseStyle4.Name = "Standard";
			gridBaseStyle4.StyleInfo.CheckBoxOptions.CheckedValue = "True";
			gridBaseStyle4.StyleInfo.CheckBoxOptions.UncheckedValue = "False";
			gridBaseStyle4.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.Window);
			gridBaseStyle4.StyleInfo.TextColor = System.Drawing.Color.DarkOliveGreen;
			this.libgrid.BaseStylesMap.AddRange(new Syncfusion.Windows.Forms.Grid.GridBaseStyle[] {
																									  gridBaseStyle1,
																									  gridBaseStyle2,
																									  gridBaseStyle3,
																									  gridBaseStyle4});
			this.libgrid.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.libgrid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.libgrid.EnableRemove = false;
			this.libgrid.ForeColor = System.Drawing.Color.Black;
			this.libgrid.Location = new System.Drawing.Point(240, 64);
			this.libgrid.Name = "libgrid";
			this.libgrid.OptimizeInsertRemoveCells = true;
			this.libgrid.Properties.BackgroundColor = System.Drawing.Color.FromArgb(((System.Byte)(214)), ((System.Byte)(222)), ((System.Byte)(231)));
			this.libgrid.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.libgrid.Size = new System.Drawing.Size(776, 569);
			this.libgrid.SmartSizeBox = false;
			this.libgrid.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.libgrid.TabIndex = 3;
			this.libgrid.UseListChangedEvent = true;
			this.libgrid.RowEnter += new Syncfusion.Windows.Forms.Grid.GridRowEventHandler(this.libgrid_RowEnter);
			// 
			// gradientPanel2
			// 
			this.gradientPanel2.BackgroundColor = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.ForwardDiagonal, System.Drawing.Color.FromArgb(((System.Byte)(244)), ((System.Byte)(237)), ((System.Byte)(211))), System.Drawing.Color.White);
			this.gradientPanel2.Border3DStyle = System.Windows.Forms.Border3DStyle.Raised;
			this.gradientPanel2.BorderColor = System.Drawing.Color.Empty;
			this.gradientPanel2.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.gradientPanel2.Controls.Add(this.lblDescription);
			this.gradientPanel2.Controls.Add(this.lblHeader);
			this.gradientPanel2.Dock = System.Windows.Forms.DockStyle.Top;
			this.gradientPanel2.Location = new System.Drawing.Point(240, 0);
			this.gradientPanel2.Name = "gradientPanel2";
			this.gradientPanel2.Size = new System.Drawing.Size(776, 64);
			this.gradientPanel2.TabIndex = 2;
			// 
			// lblDescription
			// 
			this.lblDescription.BackColor = System.Drawing.Color.Transparent;
			this.lblDescription.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDescription.ForeColor = System.Drawing.Color.Olive;
			this.lblDescription.Location = new System.Drawing.Point(8, 36);
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.Size = new System.Drawing.Size(760, 24);
			this.lblDescription.TabIndex = 1;
			this.lblDescription.Text = "Please note that Library records once added cannot be deleted";
			// 
			// lblHeader
			// 
			this.lblHeader.BackColor = System.Drawing.Color.Transparent;
			this.lblHeader.Font = new System.Drawing.Font("Verdana", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblHeader.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(166)), ((System.Byte)(140)), ((System.Byte)(38)));
			this.lblHeader.Location = new System.Drawing.Point(8, 11);
			this.lblHeader.Name = "lblHeader";
			this.lblHeader.Size = new System.Drawing.Size(552, 25);
			this.lblHeader.TabIndex = 0;
			this.lblHeader.Text = "Description";
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.libtree);
			this.panel2.Controls.Add(this.gradientPanel1);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(240, 633);
			this.panel2.TabIndex = 1;
			// 
			// gradientPanel1
			// 
			this.gradientPanel1.BackgroundColor = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.BackwardDiagonal, System.Drawing.Color.FromArgb(((System.Byte)(244)), ((System.Byte)(237)), ((System.Byte)(211))), System.Drawing.Color.White);
			this.gradientPanel1.Border3DStyle = System.Windows.Forms.Border3DStyle.Raised;
			this.gradientPanel1.BorderColor = System.Drawing.Color.Empty;
			this.gradientPanel1.BorderSingle = System.Windows.Forms.ButtonBorderStyle.None;
			this.gradientPanel1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.gradientPanel1.Controls.Add(this.label1);
			this.gradientPanel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.gradientPanel1.Location = new System.Drawing.Point(0, 0);
			this.gradientPanel1.Name = "gradientPanel1";
			this.gradientPanel1.Size = new System.Drawing.Size(240, 40);
			this.gradientPanel1.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.Transparent;
			this.label1.Font = new System.Drawing.Font("Verdana", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(166)), ((System.Byte)(140)), ((System.Byte)(38)));
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Library Setup";
			// 
			// Library
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1016, 741);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.pictureBox1);
			this.Name = "Library";
			this.Text = "Library";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.Library_Load);
			((System.ComponentModel.ISupportInitialize)(this.libtree)).EndInit();
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.libgrid)).EndInit();
			this.gradientPanel2.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.gradientPanel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void Library_Load(object sender, System.EventArgs e)
		{
			try
			{ 				
				this.libgrid.Model.Options.UseRightToLeftCompatibleTextBox = true;				
				this.libgrid.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.SelectAll;
				this.libgrid.Model.Options.WrapCellBehavior = GridWrapCellBehavior.WrapRow;

				TreeNodeAdv topnode = new TreeNodeAdv("Staff Travel Libraries");
				topnode.Tag="0"; 				
				 
				Connection conn = new Connection();
				retval = conn.GetReader("SELECT UserDescE, LibTableName, ReadWrite, descE FROM LibDescView WHERE (UserID = '" + UserData.UserID 
													+ "') AND (LibTableName LIKE 'STRV_%') AND ([Read] = 1)", ref MyReader, ref ErrMsg);
				if (retval == false)
				{MessageBox.Show(this,ErrMsg,"Staff travel - Library Error",MessageBoxButtons.OK,MessageBoxIcon.Error);}

				if (MyReader.HasRows)
				{
					TreeNodeAdv treenode;     
					while (MyReader.Read()) 
					{
						treenode = new TreeNodeAdv(MyReader["UserDescE"].ToString());  						
						treenode.Tag  = MyReader["LibTableName"].ToString()  + '@' + MyReader["ReadWrite"].ToString()  + '@' + MyReader["descE"].ToString();						
						topnode.Nodes.Add(treenode);                           
					}					
				}
				else
				{
					TreeNodeAdv treenode = new TreeNodeAdv("You Do Not Have Library Rights");
					treenode.Tag = "0";
					treenode.Enabled = false; 
					topnode.Nodes.Add(treenode);
				}

				MyReader.Close();
				topnode.Expanded = true; 
				libtree.Nodes.Add(topnode);  				
				
				
				//Register Grid Events
				this.libgrid.RowEnter +=new GridRowEventHandler(libgrid_RowEnter); 
				this.libgrid.RowEditing +=new GridRowEventHandler(libgrid_RowEditing); 
				this.libgrid.RowLeave +=new GridRowEventHandler(libgrid_RowLeave);  								 
				this.libgrid.CurrentCellActivating +=new GridCurrentCellActivatingEventHandler(libgrid_CurrentCellActivating); 
				this.libgrid.CurrentCellActivated +=new EventHandler(libgrid_CurrentCellActivated);								
				this.libgrid.CurrentCellActivateFailed +=new GridCurrentCellActivateFailedEventHandler(libgrid_CurrentCellActivateFailed); 				
				this.libgrid.Model.PasteCellText +=new GridPasteCellTextEventHandler(Model_PasteCellText);  				 												
				this.libgrid.CurrentCellKeyPress +=new KeyPressEventHandler(libgrid_CurrentCellKeyPress);  

			}
			catch(Exception EX)
			{
				MessageBox.Show(this,EX.ToString(),"Staff travel - Library Error",MessageBoxButtons.OK,MessageBoxIcon.Error); 
			}
		}

		private void libtree_AfterSelect(object sender, System.EventArgs e)
		{			
			try
			{
				this.Cursor =  Cursors.WaitCursor; 				
				string[] nodedata;								
				nodedata = libtree.SelectedNode.Tag.ToString().Split(new Char [] {'@'});   
				lblHeader.Text = libtree.SelectedNode.Text;
				if (nodedata.Length <= 1)
				{lblDescription.Text = "Please note that Library records once added cannot be deleted";}
				else
				{lblDescription.Text = nodedata[2];}	
				
				GDBG grid = new GDBG();
				if (nodedata[0] == "0") 
				{
					nodedata[0] = "LibDescView";
					string query = "SELECT UserDescE, UserDescA FROM LibDescView WHERE (UserID = '" + UserData.UserID 
						+ "') AND (LibTableName LIKE 'STRV_%') AND ([Read] = 1)";
					grid.fillgrid(query, ref libgrid, ref libDS, ref ErrMsg,nodedata);					
				}
				else
				{
					retval = grid.fillgrid("SELECT * FROM " + nodedata[0], ref libgrid, ref libDS, ref ErrMsg,nodedata);
					if (retval == false)
					{						
						if (libtree.SelectedNode.Enabled == true)
						{
							libtree.SelectedNode.NodeStyle.Text += " (Error)";												
							libtree.SelectedNode.Enabled = false;
							libtree.SelectedNode= libtree.Nodes[0];																		  
							libtree.CollapseAll();  
							MessageBox.Show(this,ErrMsg,"Staff travel - Library Error",MessageBoxButtons.OK,MessageBoxIcon.Warning); 
						}
					}					
				}				
				this.libDS.Tables[nodedata[0]].RowChanging +=new DataRowChangeEventHandler(Library_RowChanging);    
				this.Cursor =  Cursors.Arrow;				    
			}
			catch(Exception EX)
			{
				this.Cursor =  Cursors.Arrow;
				MessageBox.Show(this,EX.ToString());
			}
		
		}

		private void libgrid_RowEnter(object sender, GridRowEventArgs e)
		{
			if (e.RowIndex == this.libgrid.Model.RowCount)
			{NewRow = true;}			
			else			
			{NewRow = false;}
		}

		private void libgrid_RowEditing(object sender, GridRowEventArgs e)
		{
			NewRow = e.IsAddNew;
			if (e.IsAddNew == true)
			{Rowindex = e.RowIndex;}
		}
		private void libgrid_RowLeave(object sender, GridRowEventArgs e)
		{
			try
			{
				if(e.IsAddNew == true)
				{
					if (this.libgrid.DataSource.ToString() == "STRV_SalGradeEnt")
					{
						//Check For selected Grade
						if (this.libgrid[e.RowIndex,1].Text.Trim() == "")
						{	
							MessageBox.Show(this,"Please Select Employee Grade.","Staff Travel - Library Data Check",MessageBoxButtons.OK,MessageBoxIcon.Warning);					
							e.Cancel = true;													
						}
						else
						{
							int RowsAffected=0;
							SqlParameter [] param = new SqlParameter[4];

							param[0] = new SqlParameter("@Code",SqlDbType.VarChar,9); 
							param[0].Value = this.libgrid[e.RowIndex,1].Text;;

							param[1] = new SqlParameter("@Coral",SqlDbType.Bit,1); 
							param[1].Value = Convert.ToInt16(Convert.ToBoolean(this.libgrid[e.RowIndex,2].Text));

							param[2] = new SqlParameter("@Pearl",SqlDbType.Bit,1); 							
							param[2].Value = Convert.ToInt16(Convert.ToBoolean(this.libgrid[e.RowIndex,3].Text));

							param[3] = new SqlParameter("@Diamond",SqlDbType.Bit,1); 							
							param[3].Value = Convert.ToInt16(Convert.ToBoolean(this.libgrid[e.RowIndex,4].Text));
				
							retval = conn.ExecNonQuery("STRV_SalGradeEnt_INSERT", out RowsAffected,CommandType.StoredProcedure,ref ErrMsg,param);
							if (retval == false)
							{
								MessageBox.Show(this,ErrMsg,"Library Data Check",MessageBoxButtons.OK,MessageBoxIcon.Warning);					
								e.Cancel = true;
								
							}
							else
							{
								if (RowsAffected == 0)
								{
									MessageBox.Show(this,"Record Could Not be Updated!","Library Data Check",MessageBoxButtons.OK,MessageBoxIcon.Warning);					
									e.Cancel = true;
								}
							}						
						}
					}
					else if (this.libgrid.DataSource.ToString() == "STRV_FaresID")
					{
						//Check For Sector
						if (this.libgrid[e.RowIndex,1].Text.Trim() == "")
						{	
							MessageBox.Show(this,"Please Enter " + this.libgrid[0,1].Text  + ".","Library Data Check",MessageBoxButtons.OK,MessageBoxIcon.Warning);
							e.Cancel = true;							
						}
						else
						{
							int RowsAffected=0;
							SqlParameter [] param = new SqlParameter[7];

							param[0] = new SqlParameter("@sector", SqlDbType.VarChar, 9); 							
							param[0].Value = this.libgrid[e.RowIndex,1].CellValue;

							param[1] = new SqlParameter("@descE", SqlDbType.VarChar, 25); 							
							param[1].Value = this.libgrid[e.RowIndex,2].CellValue;

							param[2] = new SqlParameter("@from_dist", SqlDbType.Int, 4); 
							param[2].Value = this.libgrid[e.RowIndex,3].CellValue;

							param[3] = new SqlParameter("@to_dist", SqlDbType.Int, 4); 							
							param[3].Value = this.libgrid[e.RowIndex,4].CellValue;

							param[4] = new SqlParameter("@coral_fare", SqlDbType.Money, 8); 							
							param[4].Value = this.libgrid[e.RowIndex,5].CellValue;

							param[5] = new SqlParameter("@pearl_fare", SqlDbType.Money, 8); 							
							param[5].Value = this.libgrid[e.RowIndex,6].CellValue;

							param[6] = new SqlParameter("@diamond_fare", SqlDbType.Money, 8); 							
							param[6].Value = this.libgrid[e.RowIndex,7].CellValue;
				
							retval = conn.ExecNonQuery("STRV_FaresID_INSERT", out RowsAffected,CommandType.StoredProcedure,ref ErrMsg,param);
							if (retval == false)
							{
								MessageBox.Show(this,ErrMsg,"Library Data Check",MessageBoxButtons.OK,MessageBoxIcon.Warning);					
								e.Cancel = true;
								
							}
							else
							{
								if (RowsAffected == 0)
								{
									MessageBox.Show(this,"Record Could Not be Updated!","Library Data Check",MessageBoxButtons.OK,MessageBoxIcon.Warning);					
									e.Cancel = true;
								}							
							}						
						}

					}
					else if (this.libgrid.DataSource.ToString() == "STRV_AirLines")
					{
					}			 
				}
				else	//For Updating Current Records
				{
					if (this.libgrid.Binder.IsAnyDirtyField() == true)		//Check If Any Field has been Modified
					{										
						if (this.libgrid.DataSource.ToString() == "STRV_SalGradeEnt")
						{
							int RowsAffected=0;
							SqlParameter [] param = new SqlParameter[7];

							param[0] = new SqlParameter("@Code",SqlDbType.VarChar,9); 
							param[0].Value = this.libgrid[e.RowIndex,1].Text;;

							param[1] = new SqlParameter("@Coral",SqlDbType.Bit,1); 
							param[1].Value = Convert.ToInt16(Convert.ToBoolean(this.libgrid[e.RowIndex,2].Text));

							param[2] = new SqlParameter("@Pearl",SqlDbType.Bit,1); 							
							param[2].Value = Convert.ToInt16(Convert.ToBoolean(this.libgrid[e.RowIndex,3].Text));

							param[3] = new SqlParameter("@Diamond",SqlDbType.Bit,1); 							
							param[3].Value = Convert.ToInt16(Convert.ToBoolean(this.libgrid[e.RowIndex,4].Text));

							string code = this.libDS.Tables["STRV_SalGradeEnt"].Rows[e.RowIndex-1]["Code"].ToString();
							string coral = this.libDS.Tables["STRV_SalGradeEnt"].Rows[e.RowIndex-1]["Coral"].ToString();
							string pearl = this.libDS.Tables["STRV_SalGradeEnt"].Rows[e.RowIndex-1]["Pearl"].ToString();
							string diamond = this.libDS.Tables["STRV_SalGradeEnt"].Rows[e.RowIndex-1]["Diamond"].ToString();
							GridBoundRecordState  state = this.libgrid.Binder.GetRecordStateAtRowIndex(e.RowIndex);   
							
							param[4] = new SqlParameter("@nCoral",SqlDbType.Bit,1); 							
							param[4].Value = Convert.ToInt16(Convert.ToBoolean(this.libDS.Tables["STRV_SalGradeEnt"].Rows[e.RowIndex-1]["Coral"].ToString()));

							param[5] = new SqlParameter("@nPearl",SqlDbType.Bit,1); 							
							param[5].Value = Convert.ToInt16(Convert.ToBoolean(this.libDS.Tables["STRV_SalGradeEnt"].Rows[e.RowIndex]["Pearl"].ToString()));

							param[6] = new SqlParameter("@nDiamond",SqlDbType.Bit,1); 							
							param[6].Value = Convert.ToInt16(Convert.ToBoolean(this.libDS.Tables["STRV_SalGradeEnt"].Rows[e.RowIndex]["Diamond"].ToString()));
				
							retval = conn.ExecNonQuery("STRV_SalGradeEnt_UPDATE", out RowsAffected,CommandType.StoredProcedure,ref ErrMsg,param);
							if (retval == false)
							{
								MessageBox.Show(this,ErrMsg,"Library Data Check",MessageBoxButtons.OK,MessageBoxIcon.Warning);					
								e.Cancel = true;
								
							}
							else
							{
								if (RowsAffected == 0)
								{
									//DialogResult result;
                                    MessageBox.Show(this,"Record Could Not be Updated. Another User may have Modified the Data!\nClick Yes to Refresh Changes.","Library Data Check",MessageBoxButtons.YesNo,MessageBoxIcon.Warning);					
									/*if (result == DialogResult.Yes)
									{
										e.Cancel = true;
									}*/									
								}
							}						

						}
						else if (this.libgrid.DataSource.ToString() == "STRV_FaresID")
						{
						}
						else if (this.libgrid.DataSource.ToString() == "STRV_AirLines")
						{
						}
					}               
				}
			}
			catch (Exception EX)
			{
				string s = EX.ToString(); 
			}			
		}

		private void Model_PasteCellText(object sender, GridPasteCellTextEventArgs e)
		{
			e.Abort = true;
			e.Cancel = true; 
		}

		private void libgrid_CurrentCellActivating(object sender, GridCurrentCellActivatingEventArgs e)
		{
			if (NewRow == false && e.ColIndex == 1 && e.RowIndex > 0)
			{
				if (e.Options.ToString() != "NoSyncCurrentCell")
				{
					e.Cancel = true;					 
				}
			}
			else
			{
				if (this.libgrid[e.RowIndex,1].Text == "" && this.libgrid.DataSource.ToString() == "STRV_SalGradeEnt" && e.ColIndex != 1)
				{
					e.Cancel = true;
				}
			}	

		}
		private void libgrid_CurrentCellActivated(object sender, System.EventArgs e)
		{
			try
			{					
				//Check Input Languages
				if (this.libgrid.CurrentCell.ColIndex > 0)
				{
					if (this.libgrid.Binder.InternalColumns[this.libgrid.CurrentCell.ColIndex-1].StyleInfo.RightToLeft == RightToLeft.Yes)
					{System.Windows.Forms.InputLanguage.CurrentInputLanguage = InputLanguage.FromCulture(CultureInfo.CreateSpecificCulture("ar-SA"));}
					else{	System.Windows.Forms.InputLanguage.CurrentInputLanguage = InputLanguage.FromCulture(CultureInfo.CreateSpecificCulture("en-US"));	}
				}				

			}
			catch(Exception EX)
			{
				ErrorHandler.writelog(EX.ToString(), "Library",System.Diagnostics.EventLogEntryType.Error,3009);  
				MessageBox.Show(EX.Message); 
			}					
		}

		private void libgrid_CurrentCellActivateFailed(object sender, GridCurrentCellActivateFailedEventArgs e)
		{
			this.libgrid.Refresh();  
		}	

		private void libgrid_CurrentCellKeyPress(object sender, KeyPressEventArgs e)
		{		
			GridStyleInfo cellstyle = this.libgrid.CurrentCell.Renderer.StyleInfo;
        
			if (cellstyle.CellValueType == typeof(System.Int16) || cellstyle.CellValueType == typeof(System.Int32)
				|| cellstyle.CellValueType == typeof(System.Int64) || cellstyle.CellValueType == typeof(System.Decimal)
				|| cellstyle.CellValueType == typeof(System.Double) || cellstyle.CellValueType == typeof(System.Single))
			{
				if ((((int) e.KeyChar) < 48 || ((int) e.KeyChar) > 57) && ((int) e.KeyChar) != 46)
				{ 
					e.Handled = true;  					
				}
			}
			
		}

		private void Library_RowChanging(object sender, DataRowChangeEventArgs e)
		{
			//MessageBox.Show("Code - " + e.Row[0].ToString() + "/" +  e.Row[1].ToString() +  "/" + e.Row[2].ToString() + "/" + e.Row[3].ToString());
			//MessageBox.Show(e.Action.ToString());  
		}
	}
}
